package credit_balance

import (
	"context"

	"wechat-api/internal/svc"
	"wechat-api/internal/types"
	"wechat-api/internal/utils/dberrorhandler"

	"github.com/suyuan32/simple-admin-common/msg/errormsg"
	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateCreditBalanceLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUpdateCreditBalanceLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateCreditBalanceLogic {
	return &UpdateCreditBalanceLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UpdateCreditBalanceLogic) UpdateCreditBalance(req *types.CreditBalanceInfo) (*types.BaseMsgResp, error) {
	err := l.svcCtx.DB.CreditBalance.UpdateOneID(*req.Id).
		SetNotNilUserID(req.UserId).
		SetNotNilBalance(req.Balance).
		SetNotNilStatus(req.Status).
		SetNotNilOrganizationID(req.OrganizationId).
		Exec(l.ctx)

	if err != nil {
		return nil, dberrorhandler.DefaultEntError(l.Logger, err, req)
	}

	return &types.BaseMsgResp{Msg: errormsg.UpdateSuccess}, nil
}
